function [X,Faces] = read_off(filename)

fid = fopen(filename,'r');
if( fid==-1 )
    error('Cannot open the file.');
    return;
end

str = fgets(fid);   % -1 if eof
if ~strcmp(str(1:3), 'OFF')
    error('The file is not a valid OFF one.');    
end

str = fgets(fid);
sizes = sscanf(str, '%d %d', 2);
nv = sizes(1);
nf = sizes(2);

% Read vertices
[X,cnt] = fscanf(fid,'%lf %lf %lf\n', [3,nv]);
if cnt~=3*nv
    warning('Problem in reading vertices.');
end
X = X';

% Read faces
Faces = cell(nf,1);
faces_flat = fscanf(fid, '%d');
k=1;
for i=1:nf
    nvf = faces_flat(k);
    Faces{i} = faces_flat(k+1:k+nvf)+1;
    k = k + 1 + nvf;
end

fclose(fid);